if (!RedactorPlugins) var RedactorPlugins = {};

RedactorPlugins.add_remove_class_id = function()
{
    return {
        classTemplate: function(classes)
        {
            var classArray;
            var classMessage;
            var list = '';

            if (classes) {
                classArray = classes.split(' ');
                classMessage = '<p class="message">Assigned Class:</p>';
                if (classArray.length > 1) {
                    classMessage = '<p class="message">Assigned Classes:</p>';
                }
            } else {
                classArray = '';
                classMessage = '';
            }

            for (var i = 0; i < classArray.length; i++) {
               list += '<p>' + classArray[i] + '</p>';
            }

            return String()
            + '<section id="redactor-modal-class_id">'
                + classMessage
                + list
                + '<label>' + 'Add' + '</label>'
                + '<br>'
                + '<input type="text" id="redactor-add-class" />'
                + '<br>'
                + '<label>' + 'Remove' + '</label>'
                + '<br>'
                + '<input type="text" id="redactor-remove-class" />'
            + '</section>';
        },
        idTemplate: function(id)
        {
            var idMessage = '';
            var currentID;

            if (!id) {
                currentID = '';
            } else {
                currentID = '<p>' + id + '</p>';
            }

            if (id) {
                idMessage = '<p class="message">Assigned ID</p>';
            }

            return String()
            + '<section id="redactor-modal-class_id">'
                + idMessage
                + currentID
                + '<label>' + 'Set ID' + '</label>'
                + '<br>'
                + '<input type="text" id="redactor-set-id" />'
            + '</section>';
        },
        init: function()
        {
            var dropdown = {};

            // block
            dropdown.addRemoveClassBlock = { title: 'Add/Remove Block Classes ', func: this.add_remove_class_id.showClassBlock };
            dropdown.addRemoveIDBlock = { title: 'Add/Remove Block ID ', func: this.add_remove_class_id.showIDBlock };

            // link
            dropdown.addRemoveClassLink = { title: 'Add/Remove Link Classes', func: this.add_remove_class_id.showClassLink };
            dropdown.addRemoveIDLink = { title: 'Add/Remove Link ID', func: this.add_remove_class_id.showIDLink };

            // image
            dropdown.addRemoveClassImage = { title: 'Add/Remove Image Classes', func: this.add_remove_class_id.showClassImage };
            dropdown.addRemoveIDImage = { title: 'Add/Remove Image ID', func: this.add_remove_class_id.showIDImage };

            // table
            dropdown.addRemoveClassTable = { title: 'Add/Remove Table Classes', func: this.add_remove_class_id.showClassTable };
            dropdown.addRemoveIDTable = { title: 'Add/Remove Table ID', func: this.add_remove_class_id.showIDTable };

            var add_remove_class_id = this.button.add('add_remove_class_id', 'Class and ID');
            this.button.setAwesome('add_remove_class_id', 'fa-plus');
            this.button.addDropdown(add_remove_class_id, dropdown);
        },

        // block
        showClassBlock: function()
        {
            var block = this.selection.getBlock();
            var classes = block.className;

            this.modal.addTemplate('block_class_modal', this.add_remove_class_id.classTemplate(classes));

            this.modal.load('block_class_modal', 'Classes', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeClassBlock);

            this.selection.save();
            this.modal.show();
        },
        showIDBlock: function()
        {
            var block = this.selection.getBlock();
            var id = block.getAttribute('id');

            this.modal.addTemplate('block_id_modal', this.add_remove_class_id.idTemplate(id));

            this.modal.load('block_id_modal', 'ID', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeIDBlock);

            this.selection.save();
            this.modal.show();
        },
        changeClassBlock: function()
        {
            var addClass = $('#redactor-add-class').val();
            var removeClass = $('#redactor-remove-class').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            this.block.setClass(addClass);
            this.block.removeClass(removeClass);

            this.code.sync();
        },
        changeIDBlock: function()
        {
            var block = this.selection.getBlock();
            var setID = $('#redactor-set-id').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            this.block.setAttr('id', setID);

            this.utils.removeEmptyAttr(block, 'id');

            this.code.sync();
        },

        // link
        showClassLink: function()
        {
            var $link = $(this.selection.getParent());
            var classes = $link.closest('a').attr('class');

            this.modal.addTemplate('link_class_modal', this.add_remove_class_id.classTemplate(classes));

            this.modal.load('link_class_modal', 'Classes', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeClassLink);

            this.selection.save();
            this.modal.show();
        },
        showIDLink: function()
        {
            var $link = $(this.selection.getParent());
            var id = $link.closest('a').attr('id');

            this.modal.addTemplate('link_id_modal', this.add_remove_class_id.idTemplate(id));

            this.modal.load('link_id_modal', 'ID', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeIDLink);

            this.selection.save();
            this.modal.show();
        },
        changeClassLink: function()
        {
            var addClass = $('#redactor-add-class').val();
            var removeClass = $('#redactor-remove-class').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var $link = $(this.selection.getParent());
            var $linkClosest = $link.closest('a');
            $linkClosest.addClass(addClass);
            $linkClosest.removeClass(removeClass);

            this.utils.removeEmptyAttr($linkClosest, 'class');

            this.code.sync();
        },
        changeIDLink: function()
        {
            var setID = $('#redactor-set-id').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var $link = $(this.selection.getParent());
            var $linkClosest = $link.closest('a');

            $linkClosest.attr('id', setID);

            this.utils.removeEmptyAttr($linkClosest, 'id');

            this.code.sync();
        },

        // image
        showClassImage: function()
        {
            var $image = $(this.selection.getBlock());
            var classes = $image.find('img').attr('class');

            this.modal.addTemplate('image_class_modal', this.add_remove_class_id.classTemplate(classes));

            this.modal.load('image_class_modal', 'Classes', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeClassImage);

            this.selection.save();
            this.modal.show();
        },
        showIDImage: function()
        {
            var $image = $(this.selection.getBlock());
            var id = $image.find('img').attr('id');

            this.modal.addTemplate('image_id_modal', this.add_remove_class_id.idTemplate(id));

            this.modal.load('image_id_modal', 'ID', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeIDImage);

            this.selection.save();
            this.modal.show();
        },
        changeClassImage: function()
        {
            var addClass = $('#redactor-add-class').val();
            var removeClass = $('#redactor-remove-class').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var image = this.selection.getBlock();
            var $img = $(image).find('img');

            $img.addClass(addClass);
            $img.removeClass(removeClass);

            this.utils.removeEmptyAttr($img, 'class');

            this.code.sync();
        },
        changeIDImage: function()
        {
            var setID = $('#redactor-set-id').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var image = this.selection.getBlock();
            var $img = $(image).find('img');

            $img.attr('id', setID);

            this.utils.removeEmptyAttr($img, 'id');

            this.code.sync();
        },

        // table
        showClassTable: function()
        {
            var $tableItem = $(this.selection.getBlock());
            var classes = $tableItem.closest('table').attr('class');

            this.modal.addTemplate('table_class_modal', this.add_remove_class_id.classTemplate(classes));

            this.modal.load('table_class_modal', 'Classes', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeClassTable);

            this.selection.save();
            this.modal.show();
        },
        showIDTable: function()
        {
            var $tableItem = $(this.selection.getBlock());
            var id = $tableItem.closest('table').attr('id');

            this.modal.addTemplate('table_id_modal', this.add_remove_class_id.idTemplate(id));

            this.modal.load('table_id_modal', 'ID', 400);
            this.modal.createCancelButton();

            var button = this.modal.createActionButton('update');
            button.on('click', this.add_remove_class_id.changeIDTable);

            this.selection.save();
            this.modal.show();
        },
        changeClassTable: function()
        {
            var addClass = $('#redactor-add-class').val();
            var removeClass = $('#redactor-remove-class').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var tableItem = this.selection.getBlock();
            var $table = $(tableItem).closest('table');

            $table.addClass(addClass);
            $table.removeClass(removeClass);

            this.utils.removeEmptyAttr($table, 'class');

            this.code.sync();
        },
        changeIDTable: function()
        {
            var setID = $('#redactor-set-id').val();

            this.modal.close();
            this.selection.restore();

            this.buffer.set();

            var tableItem = this.selection.getBlock();
            var $table = $(tableItem).closest('table');

            $table.attr('id', setID);

            this.utils.removeEmptyAttr($table, 'id');

            this.code.sync();
        }
    };
};